import { Common } from "@ethereumjs/common";
import { AccessListEIP2930Transaction, BlobEIP4844Transaction, FeeMarketEIP1559Transaction, LegacyTransaction, TypedTxData } from "@ethereumjs/tx";
type CustomChainArg = Parameters<typeof Common.custom>[0];
/**
 * Sign ethereum transaction data offline. Can be used with both mainnet and custom chains.
 *
 * @param txData transaction data (format must be compatible with @ethereumjs/tx)
 * @param privateKey HEX private signing key
 * @param customChainInfo optional custom chain information (default: mainnet)
 *
 * @returns serialized transaction, txId (hash) and signedTransaction object
 */
export declare function signTransaction(txData: TypedTxData, privateKey: string, customChainInfo?: CustomChainArg): {
    serializedTransactionHex: string;
    txId: string;
    signedTransactionObject: LegacyTransaction | AccessListEIP2930Transaction | FeeMarketEIP1559Transaction | BlobEIP4844Transaction;
};
export {};
