import { Web3Error } from "web3";
import { ContractJsonDefinition, ContractKeychainDefinition, DeployedContractJsonDefinition, GasTransactionConfig, GasTransactionConfigEIP1559, GasTransactionConfigLegacy, Web3SigningCredentialCactiKeychainRef, Web3SigningCredentialGethKeychainPassword, Web3SigningCredentialNone, Web3SigningCredentialPrivateKeyHex, Web3SigningCredentialType } from "../generated/openapi/typescript-axios/api";
export declare function isWeb3SigningCredentialPrivateKeyHex(x?: {
    type?: Web3SigningCredentialType;
}): x is Web3SigningCredentialPrivateKeyHex;
export declare function isWeb3SigningCredentialNone(x?: {
    type?: Web3SigningCredentialType;
}): x is Web3SigningCredentialNone;
export declare function isWeb3SigningCredentialGethKeychainPassword(x?: {
    type?: Web3SigningCredentialType;
}): x is Web3SigningCredentialGethKeychainPassword;
export declare function isWeb3SigningCredentialCactiKeychainRef(x?: {
    type?: Web3SigningCredentialType;
    keychainEntryKey?: string | unknown;
    keychainId?: string | unknown;
}): x is Web3SigningCredentialCactiKeychainRef;
export declare function isGasTransactionConfigLegacy(gasConfig: GasTransactionConfig): gasConfig is GasTransactionConfigLegacy;
export declare function isGasTransactionConfigEIP1559(gasConfig: GasTransactionConfig): gasConfig is GasTransactionConfigEIP1559;
export declare function isContractJsonDefinition(contract: unknown): contract is ContractJsonDefinition;
export declare function isDeployedContractJsonDefinition(contract: unknown): contract is DeployedContractJsonDefinition;
export declare function isContractKeychainDefinition(contract: unknown): contract is ContractKeychainDefinition;
export declare function isWeb3Error(error: unknown): error is Web3Error;
