import { Express, Request, Response } from "express";
import OAS from "../../json/openapi.json";
import { IWebServiceEndpoint, IExpressRequestHandler, IEndpointAuthzOptions } from "@hyperledger/cactus-core-api";
import { LogLevelDesc, IAsyncProvider } from "@hyperledger/cactus-common";
import { PluginLedgerConnectorEthereum } from "../plugin-ledger-connector-ethereum";
export interface IGetPrometheusExporterMetricsEndpointV1Options {
    connector: PluginLedgerConnectorEthereum;
    logLevel?: LogLevelDesc;
}
export declare class GetPrometheusExporterMetricsEndpointV1 implements IWebServiceEndpoint {
    readonly options: IGetPrometheusExporterMetricsEndpointV1Options;
    private readonly log;
    constructor(options: IGetPrometheusExporterMetricsEndpointV1Options);
    getExpressRequestHandler(): IExpressRequestHandler;
    get oasPath(): (typeof OAS.paths)["/api/v1/plugins/@hyperledger/cactus-plugin-ledger-connector-ethereum/get-prometheus-exporter-metrics"];
    getPath(): string;
    getVerbLowerCase(): string;
    getOperationId(): string;
    getAuthorizationOptionsProvider(): IAsyncProvider<IEndpointAuthzOptions>;
    registerExpress(expressApp: Express): Promise<IWebServiceEndpoint>;
    handleRequest(req: Request, res: Response): Promise<void>;
}
