import { LogLevelDesc } from "@hyperledger/cactus-common";
/**
 * Overwrites for artillery test config
 */
export type BenchmarkEnvironmentConfig = {
    target: string;
    variables: Record<string, string[]>;
};
export declare function getDefaultArtilleryConfigPath(): string;
export declare function getDefaultArtilleryFunctionsPath(): string;
/**
 * Setup new test environment (ledger and connector).
 *
 * @param envLogLevel log level for test environment.
 * @returns configuration overwrites for newly created environment
 */
export declare function setupBenchmarkEnvironment(envLogLevel?: LogLevelDesc): Promise<BenchmarkEnvironmentConfig>;
/**
 * Cleanup test environment (stop the ledger, close the server)
 */
export declare function cleanupBenchmarkEnvironment(): Promise<void>;
